// Fig. 23.11: UsingHugeIntegerJFrame.java
// Client desktop application for the HugeInteger web service.
package com.deitel.java.hugeintegerclient;

import com.deitel.java.hugeinteger.HugeInteger;
import com.deitel.java.hugeinteger.HugeIntegerService;
import javax.swing.JOptionPane;

public class UsingHugeIntegerJFrame extends javax.swing.JFrame
{
   // references the service endpoint interface object (i.e., the proxy)
   private HugeInteger hugeIntegerProxy; 

   // no-argument constructor
   public UsingHugeIntegerJFrame()
   {
      initComponents();

      try
      {
         // create the objects for accessing the HugeInteger web service
         HugeIntegerService hugeIntegerService = new HugeIntegerService();
         hugeIntegerProxy = hugeIntegerService.getHugeIntegerPort();
      } // end try
      catch ( Exception exception )
      {
         exception.printStackTrace();
         System.exit( 1 );
      } // end catch
   } // end UsingHugeIntegerJFrame constructor

   // The initComponents method is autogenerated by Netbeans and is called
   // from the constructor to initialize the GUI. This method is not shown
   // here to save space. Open UsingHugeIntegerJFrame.java in this
   // example's folder to view the complete generated code.
   @SuppressWarnings( "unchecked" )
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents() {

      directionsJLabel = new javax.swing.JLabel();
      firstJTextField = new javax.swing.JTextField();
      secondJTextField = new javax.swing.JTextField();
      addJButton = new javax.swing.JButton();
      subtractJButton = new javax.swing.JButton();
      greaterThanJButton = new javax.swing.JButton();
      lessThanJButton = new javax.swing.JButton();
      equalsJButton = new javax.swing.JButton();
      resultsJScrollPane = new javax.swing.JScrollPane();
      resultsJTextArea = new javax.swing.JTextArea();

      setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
      setTitle("Using the HugeInteger Web Service");

      directionsJLabel.setText("Enter two positive integers up to 100 digits each:");

      addJButton.setText("Add");
      addJButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            addJButtonActionPerformed(evt);
         }
      });

      subtractJButton.setText("Subtract");
      subtractJButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            subtractJButtonActionPerformed(evt);
         }
      });

      greaterThanJButton.setText("Greater Than");
      greaterThanJButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            greaterThanJButtonActionPerformed(evt);
         }
      });

      lessThanJButton.setText("Less Than");
      lessThanJButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            lessThanJButtonActionPerformed(evt);
         }
      });

      equalsJButton.setText("Equals");
      equalsJButton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            equalsJButtonActionPerformed(evt);
         }
      });

      resultsJTextArea.setColumns(20);
      resultsJTextArea.setRows(5);
      resultsJScrollPane.setViewportView(resultsJTextArea);

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
               .addComponent(secondJTextField, javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(directionsJLabel, javax.swing.GroupLayout.Alignment.LEADING)
               .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                  .addComponent(addJButton, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(subtractJButton)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(greaterThanJButton)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(lessThanJButton)
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addComponent(equalsJButton))
               .addComponent(resultsJScrollPane, javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(firstJTextField, javax.swing.GroupLayout.Alignment.LEADING))
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );

      layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {addJButton, equalsJButton, greaterThanJButton, lessThanJButton, subtractJButton});

      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(directionsJLabel)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(firstJTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(secondJTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(addJButton)
               .addComponent(subtractJButton)
               .addComponent(greaterThanJButton)
               .addComponent(lessThanJButton)
               .addComponent(equalsJButton))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(resultsJScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );

      pack();
   }// </editor-fold>//GEN-END:initComponents

   // invokes HugeInteger web service's add method to add HugeIntegers
   private void addJButtonActionPerformed(//GEN-FIRST:event_addJButtonActionPerformed
      java.awt.event.ActionEvent evt )
   {//GEN-HEADEREND:event_addJButtonActionPerformed
      String firstNumber = firstJTextField.getText();
      String secondNumber = secondJTextField.getText();

      if ( isValid( firstNumber ) && isValid( secondNumber ) )
      {
         try
         {
            resultsJTextArea.setText(
               hugeIntegerProxy.add( firstNumber, secondNumber ) );
         } // end try
         catch ( Exception e )
         {
            JOptionPane.showMessageDialog( this, e.toString(),
               "Add method failed", JOptionPane.ERROR_MESSAGE );
            e.printStackTrace();
         } // end catch
      } // end if
   }//GEN-LAST:event_addJButtonActionPerformed

   // invokes HugeInteger web service's subtract method to subtract the
   // second HugeInteger from the first
   private void subtractJButtonActionPerformed(//GEN-FIRST:event_subtractJButtonActionPerformed
      java.awt.event.ActionEvent evt )
   {//GEN-HEADEREND:event_subtractJButtonActionPerformed
      String firstNumber = firstJTextField.getText();
      String secondNumber = secondJTextField.getText();

      if ( isValid( firstNumber ) && isValid( secondNumber ) )
      {
         try
         {
            resultsJTextArea.setText(
               hugeIntegerProxy.subtract( firstNumber, secondNumber ) );
         } // end try
         catch ( Exception e )
         {
            JOptionPane.showMessageDialog( this, e.toString(),
               "Subtract method failed", JOptionPane.ERROR_MESSAGE );
            e.printStackTrace();
         } // end catch
      } // end if
   }//GEN-LAST:event_subtractJButtonActionPerformed

   // invokes HugeInteger web service's bigger method to determine whether
   // the first HugeInteger is greater than the second
   private void greaterThanJButtonActionPerformed(//GEN-FIRST:event_greaterThanJButtonActionPerformed
      java.awt.event.ActionEvent evt )
   {//GEN-HEADEREND:event_greaterThanJButtonActionPerformed
      String firstNumber = firstJTextField.getText();
      String secondNumber = secondJTextField.getText();

      if ( isValid( firstNumber ) && isValid( secondNumber ) )
      {
         try
         {
            boolean result =
               hugeIntegerProxy.bigger( firstNumber, secondNumber );
            resultsJTextArea.setText( String.format( "%s %s %s %s",
               firstNumber, ( result ? "is" : "is not" ), "greater than",
               secondNumber ) );
         } // end try
         catch ( Exception e )
         {
            JOptionPane.showMessageDialog( this, e.toString(),
               "Bigger method failed", JOptionPane.ERROR_MESSAGE );
            e.printStackTrace();
         } // end catch
      } // end if
   }//GEN-LAST:event_greaterThanJButtonActionPerformed

   // invokes HugeInteger web service's smaller method to determine
   // whether the first HugeInteger is less than the second
   private void lessThanJButtonActionPerformed(//GEN-FIRST:event_lessThanJButtonActionPerformed
      java.awt.event.ActionEvent evt )
   {//GEN-HEADEREND:event_lessThanJButtonActionPerformed
      String firstNumber = firstJTextField.getText();
      String secondNumber = secondJTextField.getText();

      if ( isValid( firstNumber ) && isValid( secondNumber ) )
      {
         try
         {
            boolean result =
               hugeIntegerProxy.smaller( firstNumber, secondNumber );
            resultsJTextArea.setText( String.format( "%s %s %s %s",
               firstNumber, ( result ? "is" : "is not" ), "less than",
               secondNumber ) );
         } // end try
         catch ( Exception e )
         {
            JOptionPane.showMessageDialog( this, e.toString(),
               "Smaller method failed", JOptionPane.ERROR_MESSAGE );
            e.printStackTrace();
         } // end catch
      } // end if
   }//GEN-LAST:event_lessThanJButtonActionPerformed

   // invokes HugeInteger web service's equals method to determine whether
   // the first HugeInteger is equal to the second
   private void equalsJButtonActionPerformed(//GEN-FIRST:event_equalsJButtonActionPerformed
      java.awt.event.ActionEvent evt )
   {//GEN-HEADEREND:event_equalsJButtonActionPerformed
      String firstNumber = firstJTextField.getText();
      String secondNumber = secondJTextField.getText();

      if ( isValid( firstNumber ) && isValid( secondNumber ) )
      {
         try
         {
            boolean result =
               hugeIntegerProxy.equals( firstNumber, secondNumber );
            resultsJTextArea.setText( String.format( "%s %s %s %s",
               firstNumber, ( result ? "is" : "is not" ), "equal to",
               secondNumber ) );
         } // end try
         catch ( Exception e )
         {
            JOptionPane.showMessageDialog( this, e.toString(),
               "Equals method failed", JOptionPane.ERROR_MESSAGE );
            e.printStackTrace();
         } // end catch
      } // end if
   }//GEN-LAST:event_equalsJButtonActionPerformed

   // checks the size of a String to ensure that it is not too big
   // to be used as a HugeInteger; ensure only digits in String
   private boolean isValid( String number )
   {
      // check String's length
      if ( number.length() > 100 )
      {
         JOptionPane.showMessageDialog( this,
            "HugeIntegers must be <= 100 digits.",
            "HugeInteger Overflow", JOptionPane.ERROR_MESSAGE );
         return false;
      } // end if

      // look for nondigit characters in String
      for ( char c : number.toCharArray() )
      {
         if ( !Character.isDigit( c ) )
         {
            JOptionPane.showMessageDialog( this,
               "There are nondigits in the String",
               "HugeInteger Contains Nondigit Characters",
               JOptionPane.ERROR_MESSAGE );
            return false;
         } // end if
      } // end for

      return true; // number can be used as a HugeInteger
   } // end method validate

   // main method begins execution
   public static void main( String args[] )
   {
      java.awt.EventQueue.invokeLater(
         new Runnable()
         {
            public void run()
            {
               new UsingHugeIntegerJFrame().setVisible( true );
            } // end method run
         } // end anonymous inner class
      ); // end call to java.awt.EventQueue.invokeLater
   } // end main

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JButton addJButton;
   private javax.swing.JLabel directionsJLabel;
   private javax.swing.JButton equalsJButton;
   private javax.swing.JTextField firstJTextField;
   private javax.swing.JButton greaterThanJButton;
   private javax.swing.JButton lessThanJButton;
   private javax.swing.JScrollPane resultsJScrollPane;
   private javax.swing.JTextArea resultsJTextArea;
   private javax.swing.JTextField secondJTextField;
   private javax.swing.JButton subtractJButton;
   // End of variables declaration//GEN-END:variables
} // end class UsingHugeIntegerJFrame


/**************************************************************************
 * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
